"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var useMountedState_1 = tslib_1.__importDefault(require("./useMountedState"));
var useUpdate_1 = tslib_1.__importDefault(require("./useUpdate"));
var useUpdateEffect_1 = tslib_1.__importDefault(require("./useUpdateEffect"));
function useStateList(stateSet) {
    if (stateSet === void 0) { stateSet = []; }
    var isMounted = useMountedState_1.default();
    var update = useUpdate_1.default();
    var index = react_1.useRef(0);
    // If new state list is shorter that before - switch to the last element
    useUpdateEffect_1.default(function () {
        if (stateSet.length <= index.current) {
            index.current = stateSet.length - 1;
            update();
        }
    }, [stateSet.length]);
    return {
        state: stateSet[index.current],
        next: react_1.useCallback(function () {
            // do nothing on unmounted component
            if (!isMounted()) {
                return;
            }
            // act only if stateSet has element within
            if (stateSet.length) {
                index.current = (index.current + 1) % stateSet.length;
                update();
            }
        }, [stateSet, index]),
        prev: react_1.useCallback(function () {
            // do nothing on unmounted component
            if (!isMounted()) {
                return;
            }
            // act only if stateSet has element within
            if (stateSet.length) {
                index.current = index.current - 1 < 0 ? stateSet.length - 1 : index.current - 1;
                update();
            }
        }, [stateSet, index]),
    };
}
exports.default = useStateList;
